%
%
%given the location of parameters, return the pair (k,j)
%if k=0, 1<=j<=p, this refers to the main effect x_j
%if 1<=k<=p, k<=j<=p, this refers to the interaction (x_k,x_j)
%k=j represents the quadratic effect of x_j
%
%
%function [k,j]=findpair(index,p);
%  %maxlen = (p^2+3*p)/2;  index should be smaller than maxlen
%  crl = zeros(p,1);
%  crl(1)=p;
%  for m=1:p
%	crl(m+1)=crl(m)+p-(m-1);
%  end
%  k = sum(index>crl);
%  if k==0 
%    j = index;
%  else
%    j = index - crl(k)-1+k;
%  end
 
function [k,j]=findpair(index,p)
  %maxlen = (p^2+3*p)/2;  index should be smaller than maxlen
  k = p-floor(sqrt(p^2+3*p-2*index));
  j = index-k*p+k*(k-1)/2;
  if j>p
     k = k + 1;
     j = index-k*p+k*(k-1)/2;
  end
  