function [Beta]=LongBeta(ncov,beta0,interpos, interc);
    totlen = ncov*(ncov+3)/2;                                               %total length
    Beta = zeros(totlen,1);                                                 %relevant design matrix
    Beta(1:ncov) = beta0;                                                   %E(X'*X) and E(X'*Y)
    for m =1:length(interc)
       k = interpos(m,1);
       j = interpos(m,2);
       pos = k*ncov-(k-1)*(k-2)/2+(j-k+1);
       Beta(pos) = interc(m);
    end
    