%
%
%returns the index location for the main effects and interactions 
% for (x_k, x_j) when either k or j belongs to subid
%For example: if p = 4, subid = (1,4)
%then return 1,4,(1,1),(1,2),(1,3),(1,4),(2,4),(3,4),(4,4) 
%corresponds to 1,4,5,6,7,8,11,13,14
%For example: if p = 4, subid = (1,3)
%then return 1,3,(1,1),(1,2),(1,3),(1,4),(2,3),(3,3),(3,4) 
%corresponds to 1,3,5,6,7,8,10,12,13
%
%
function myid=genid(subid,p);
  myid = subid;
  for kk=1:p
      for jj=kk:p
          if ismember(kk,subid)>0 | ismember(jj,subid)>0
                myid = [myid findid(kk,jj,p)];
          end
      end
  end
  